rawset(_G,"P_ChangeOrigin", function(mo, x,y,z, inter)
	if (P_MoveOrigin(mo,x,y,z) or P_SetOrigin(mo,x,y,z))
		if inter
			P_MoveOrigin(mo,x,y,z)
		else
			P_SetOrigin(mo,x,y,z)
		end
	elseif P_TeleportMove(mo,x,y,z)
		P_TeleportMove(mo,x,y,z)
	end
end)
rawset(_G,"AddToTable", function(mo,t)
	for i,k in pairs(t)
		local co = t[i]
		if co and co.valid
		and co == mo
			table.remove(t, i)
		end
	end
	table.insert(t,mo)
end)

rawset(_G, "CA_DODGEROLL", 27) --2007
rawset(_G, "CA2_WRENCH", 10) --10

addHook("PlayerThink", function(player)
	if player.valid --Extra stuff
	and not player.spectator
		if player.charability == CA_DODGEROLL
			player.doflash = $ or 0
			if player.doflash
				player.doflash = $-1
				if (player.doflash&1)
					player.mo.flags2 = $|MF2_DONTDRAW
				else
					player.mo.flags2 = $&~MF2_DONTDRAW
				end
				player.stopflash = true
			elseif player.stopflash
				player.mo.flags2 = $&~MF2_DONTDRAW
				player.stopflash = false
			end
			player.dodging = $ or 0
			if player.dodgeroll
				if P_IsObjectOnGround(player.mo)
					player.dodgeroll = false
				else
					player.dodging = $+1
					if not (player.dodging&5)
					and player.dodging <= 20
						local gh = P_SpawnGhostMobj(player.mo)
						gh.fuse = 5
						gh.colorized = true
						if gh.tracer and gh.tracer.valid
							gh.tracer.fuse = 5
							gh.tracer.colorized = true
						end
					end
					if player.dodging >= 25
					and player.mo.state == S_PLAY_ROLL
						player.dodgeroll = false
						player.mo.state = S_PLAY_FALL
					end
				end
			elseif player.dodging
				player.dodging = 0
			end
		end
		if player.charability2 == CA2_WRENCH
			player.swing = $ or 0
			player.swingcd = $ or 0
			player.realcombo = $ or 0
			player.swingcombo = $ or 0
			if player.swingcd player.swingcd = $-1 end
			if player.swingcombo
				player.drawangle = player.mo.angle
				player.swingcombo = $-1
				player.combo = true
			elseif player.combo
				player.realcombo = 0
				player.combo = false
			end
		end
	end
end)

freeslot("MT_WRENCH","SPR_WRCH","SPR_WRCV", "S_WRENCH_LEFT","S_WRENCH_RIGHT","S_WRENCH_UP","S_WRENCH_DOWN")
local statechange = 2
local statetics = 8
states[S_WRENCH_LEFT] = {SPR_WRCH,FF_ANIMATE|FF_FLOORSPRITE,statetics,nil,D,statechange,S_NULL}
states[S_WRENCH_RIGHT] = {SPR_WRCH,FF_ANIMATE|FF_FLOORSPRITE|FF_HORIZONTALFLIP,statetics,nil,D,statechange,S_NULL}
states[S_WRENCH_UP] = {SPR_WRCV,FF_ANIMATE|FF_PAPERSPRITE|FF_VERTICALFLIP,statetics,nil,D,statechange,S_NULL}
states[S_WRENCH_DOWN] = {SPR_WRCV,FF_ANIMATE|FF_PAPERSPRITE,statetics,nil,D,statechange,S_NULL}
mobjinfo[MT_WRENCH] = {
	-1,             // doomednum
	S_WRENCH_LEFT,     // spawnstate
	1000,           // spawnhealth
	S_NULL,         // seestate
	sfx_None,       // seesound
	8,              // reactiontime
	sfx_None,       // attacksound
	S_NULL,         // painstate
	0,              // painchance
	sfx_None,       // painsound
	S_NULL,         // meleestate
	S_NULL,         // missilestate
	S_NULL,         // deathstate
	S_NULL,         // xdeathstate
	sfx_None,       // deathsound
	4*FRACUNIT,     // speed
	4*FRACUNIT,     // radius
	4*FRACUNIT,     // height
	1,              // display offset
	100,              // mass
	0,              // damage
	sfx_None,       // activesound
	MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOCLIP, // flags
	S_NULL          // raisestate
}

states[freeslot("S_WRENCHH")] = {SPR_NULL,A,5,nil,0,0,S_NULL}
mobjinfo[freeslot("MT_WRENCHHITBOX")] = {
	-1,             // doomednum
	S_WRENCHH,    // spawnstate
	1,              // spawnhealth
	S_NULL,         // seestate
	sfx_None,       // seesound
	8,              // reactiontime
	sfx_None,       // attacksound
	S_NULL,         // painstate
	0,              // painchance
	sfx_None,       // painsound
	S_NULL,         // meleestate
	S_NULL,         // missilestate
	S_NULL,         // deathstate
	S_NULL,         // xdeathstate
	sfx_None,       // deathsound
	16*FRACUNIT,    // speed
	34*FRACUNIT,     // radius
	82*FRACUNIT,     // height
	0,              // display offset
	100,              // mass
	1,              // damage
	sfx_None,       // activesound
	MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY, // flags
	S_NULL          // raisestate
}
addHook("AbilitySpecial", function(player) --Dodge roll
	if player.valid
	and not player.spectator
	and player.charability == CA_FLY
		P_SetObjectMomZ(player.mo,3*FRACUNIT,true)
		player.mo.state = S_PLAY_FLY
		player.mo.frame = A
		player.mo.tics = 5
		player.mo.sprite2 = SPR2_FLY_
		player.drawangle = player.mo.angle
	end
end)

addHook("MobjThinker", function(mo)
	if mo and mo.valid
	and mo.target and mo.target.valid
		P_ChangeOrigin(mo,mo.target.x,mo.target.y,mo.target.z+mo.target.height/2,true)
		mo.momx = mo.target.momx
		mo.momy = mo.target.momy
		mo.momz = mo.target.momz
		if mo.target.player and mo.target.player.valid
			mo.angle = mo.target.player.drawangle
		else
			mo.angle = mo.target.angle
		end
	end
end, MT_WRENCH)