addHook("PlayerThink", function(player)
    if player.mo and player.mo.valid and player.mo.skin == "henchman" then
        -- The boost button. I/O shenanigans.
        if not player.boostbutton then
            local file = io.openlocal("client/boostcmd.txt", "r")
            if file then
                local text = file:read("*a")
                if text == "" then
                    player.boostbutton = BT_CUSTOM1
                else
                    player.boostbutton = tonumber(text)
                end
                file:close()
            else
                player.boostbutton = BT_CUSTOM1
            end
        end
    end
end)

-- snek
local strToButton = {
    CUSTOM1 = BT_CUSTOM1,
    CUSTOM2 = BT_CUSTOM2,
    CUSTOM3 = BT_CUSTOM3,
    FIRE = BT_ATTACK,
    FIRENORMAL = BT_FIRENORMAL,
    TOSSFLAG = BT_TOSSFLAG
}

-- The command.
COM_AddCommand("boostcmd", function(player, arg1)
    io.openlocal("client/boostcmd.txt", "a"):close()
    local file = io.openlocal("client/boostcmd.txt", "w")
    if strToButton[arg1] then
        player.boostbutton = strToButton[arg1]
        file:write(strToButton[arg1])
        print("Button set successfully.")
    else
        print("Not a valid button.")
    end
    file:close()
end)

-- LibreBoost, by ffoxD. Reusable content, use as long as you credit.
local function LibreBoost(player)
    -- Prevents the code from running in NiGHTs special stages.
    if (maptol & TOL_NIGHTS) then
        return
    end
    if player.mo and player.mo.valid and player.mo.skin == "henchman" then
        -- Lets the player boost.
        if not (player.pflags & PF_STASIS)
			and not (player.boomspindash)
            and not (player.pflags & PF_FULLSTASIS)
            and not (player.pflags & PF_STARTDASH)
            and not (player.pflags & PF_FINISHED)
            and player.playerstate ~= PST_DEAD
            and player.powers[pw_carry] == CR_NONE
            and not P_PlayerInPain(player) then
            if not (player.cmd.buttons & player.boostbutton) then
                player.canboost = true
            end
        else
            player.canboost = false
        end
        if player.canboost == nil then
            player.canboost = true
        end
        -- Tells the game when the player shall boost, and whenever not.
        if (player.cmd.buttons & player.boostbutton)
            and player.canboost then
            player.boosting = true
        else
            player.boosting = false
        end
        -- Determines how fast shall the player boost.
        player.boostspeed = 5 * player.normalspeed / 3
        -- Stores the player's speed angle.
        if player.speed > player.normalspeed then
            player.momangle2 = R_PointToAngle2(0,0,player.mo.momx,player.mo.momy)
        else
            player.momangle2 = player.mo.angle
        end
        -- What happens if the player boosts.
        if player.boosting then
            if not player.cmd.forwardmove then
                player.cmd.forwardmove = 50 -- Intentionally not in PreThinkFrame
            end
            player.drawangle = player.momangle2
            player.charflags = $|SF_NOSKID|SF_RUNONWATER|SF_CANBUSTWALLS
            if player.mo.state == S_PLAY_STND
                or player.mo.state == S_PLAY_WALK
                or player.mo.state == S_PLAY_WAIT
                or player.mo.state == S_PLAY_EDGE then
                player.mo.state = S_PLAY_RUN
            end
            if player.speed < (player.boostspeed) then
                P_Thrust(player.mo, player.momangle2, player.boostspeed - player.speed)
            end
        else -- What happens if the player isn't boosting. Mostly resetting values.
            if not (skins[player.mo.skin].flags & SF_NOSKID) then
                player.charflags = $ & ~SF_NOSKID
            end
            if not (skins[player.mo.skin].flags & SF_RUNONWATER) then
                player.charflags = $ & ~SF_RUNONWATER
            end
            if not (skins[player.mo.skin].flags & SF_CANBUSTWALLS ) then
                player.charflags = $ & ~SF_CANBUSTWALLS
            end
            player.hasnomomentum = true -- Prevents XMomentum from preserving your speed.
        end
    end
end

addHook("PlayerThink", LibreBoost)


addHook("MobjMoveBlocked", function(mo) -- You shall not boost if stopped by walls.
    local player = mo.player
    player.canboost = false
    player.boosting = false
end, MT_PLAYER)

freeslot("SPR_KLIT")

local function boosteffect(p)
    if p.mo.skin == "henchman"
    and p.boosting == true
    and p.canspawn == true then
        local playerfrbo = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_FRONTIERSBOOST)
        playerfrbo.color = p.mo.color
        playerfrbo.blendmode = AST_ADD
        playerfrbo.angle = p.cmd.angleturn << 16 + R_PointToAngle2(0, 0, p.cmd.forwardmove*FRACUNIT, -p.cmd.sidemove*FRACUNIT) + ANGLE_90
        playerfrbo.scale = p.mo.scale
        playerfrbo.destscale = p.mo.scale
        playerfrbo.tics = 5
        p.canspawn = false
    end
end

addHook("PlayerThink", boosteffect)

addHook("PlayerThink", function(p)
    if p.mo.skin == "henchman"
    and p.boosting == false then
        p.canspawn = true
    end
end)

addHook("PlayerThink", function(p)
    if p.mo.skin == "henchman"
    and not P_IsObjectOnGround(p.mo)
    and p.boosting == true
    and not p.powers[pw_super]
    and p.alreadyairboosted ~= true then
        P_SetObjectMomZ(p.mo, 10*FRACUNIT)
        p.mo.state = S_PLAY_FALL
        p.alreadyairboosted = true
    end
end)

addHook("PlayerThink", function(p)
    if p.mo.skin == "henchman"
    and P_IsObjectOnGround(p.mo) then
        p.alreadyairboosted = false
    end
end)

addHook("PlayerCanDamage", function(player) -- Player kills enemies while boosting
    if player.boosting then
        return true
    end
end)

addHook("MobjMoveBlocked", function(mo) -- You shall not boost if stopped by walls.
    local player = mo.player
    player.canboost = false
    player.boosting = false
end, MT_PLAYER)

addHook("MobjMoveCollide", function(mo, spike) -- Spike breaking by ARJr.
    if mo.valid
    and (mo.type == MT_PLAYER)
    and mo.player.boosting
    and spike.type == MT_SPIKE then
        if (spike.z >= (mo.z - 16*FRACUNIT)) and (spike.z <= (mo.z + mo.height + 16*FRACUNIT)) then
            P_KillMobj(spike, mo, mo)
        elseif (spike.flags2 & MF2_OBJECTFLIP)
        and (spike.z <= (mo.z - 16*FRACUNIT)) and (spike.z >= (mo.z + mo.height+ 16*FRACUNIT)) then
            P_KillMobj(spike, mo, mo)
        end
    end
end)

freeslot("MT_BSFX", "sfx_boost")
sfxinfo[sfx_boost].caption = "Boost!"

local isBoostSoundPlaying = false
local isScreenShaking = false -- Add this global variable

addHook("PlayerThink", function(player)
    if player.mo and player.mo.valid and player.mo.skin == "henchman" then
        if player.boosting then
            if not isBoostSoundPlaying then
                S_StartSound(player.mo, sfx_boost, player)
                isBoostSoundPlaying = true
            end
            
            if not isScreenShaking then
                P_StartQuake(10 * FRACUNIT, TICRATE / 2)
                isScreenShaking = true
            end
        else
            isBoostSoundPlaying = false
            isScreenShaking = false
        end
    end
end)

addHook("PlayerThink", function(player)
    if player.mo and player.mo.valid then
        searchBlockmap("objects", function(refmo, mo)
            if (mo.type == MT_RING or mo.type == MT_COIN)
            and mo.health > 0
				if mo.target then
				local angle = R_PointToAngle2(mo.x, mo.y, mo.target.x, mo.target.y)
				local vangle = R_PointToAngle2(0, 0, R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y), mo.target.z - mo.z)
					mo.momx = FixedMul(FixedMul(cos(angle), cos(vangle)), player.boostspeed*3/2)
					mo.momy = FixedMul(FixedMul(sin(angle), cos(vangle)), player.boostspeed*3/2)
					mo.momz = FixedMul(sin(vangle), player.boostspeed*3/2)
				end
                if (P_AproxDistance(P_AproxDistance(player.mo.x-mo.x, player.mo.y-mo.y),player.mo.z-mo.z) < 192*FRACUNIT
                or P_CheckSight(player.mo, mo)) and player.boosting then
                    mo.target = player.mo
                end
            end
        end, player.mo)
    end
end)

addHook("PlayerThink", function(player)
    if player and player.valid and player.mo and player.mo.valid and player.mo.skin == "henchman" then
        if player.boosting then
            local aitrail = P_SpawnGhostMobj(player.mo)
            aitrail.fuse = 3
            aitrail.colorized = true
			aitrail.blendmode = AST_ADD
        end
    end
end)