local DASHTHR = 2*TICRATE
local DASHMAX = 15*TICRATE + 2*TICRATE

-- Smooth Trail script by ffoxD.
-- Reusable, use with credit.
local function SmoothTrail(mo, trailmo, freq)
    -- Real Z momentum thingy plus leveltime checks.
    -- You can replace all this with mo.momz+mo.pmomz but that stays at 0 when on slopes and on ground.
    if not mo.prevz or not mo.prevleveltime or (mo.prevleveltime ~= leveltime - 1) then
       mo.prevz = mo.z
    end
    local rmomz = mo.z - mo.prevz
    mo.prevz = mo.z
    mo.prevleveltime = leveltime
    -- Handy local variables.
    local mospeed = R_PointToDist2(0, 0, R_PointToDist2(0, 0, mo.momx, mo.momy), rmomz)
    local dist = (mospeed/freq)
    -- The loop, repeats until it spawns all the thok objects.
    for i = dist, 1, -1 do
        local spawnedmo = P_SpawnMobjFromMobj(mo, (mo.momx/dist)*i, (mo.momy/dist)*i, (rmomz/dist)*i, trailmo)
        spawnedmo.color = SKINCOLOR_ORANGE
        spawnedmo.blendmode = AST_ADD -- blend
		spawnedmo.target = mo
		if trailmo == MT_THOK
			spawnedmo.spriteyoffset = -8*FRACUNIT
			spawnedmo.fuse = TICRATE*6
			spawnedmo.tics = TICRATE*6
			if P_IsObjectOnGround(mo)
				spawnedmo.scale = FixedMul(mo.scale,FRACUNIT/4*5)
				spawnedmo.destscale = mo.scale
			end	
			if mo.eflags & MFE_UNDERWATER
				spawnedmo.fuse = TICRATE*7
				spawnedmo.tics = TICRATE*7
			end
			if (gametyperules & GTR_TAG)
				spawnedmo.fuse = TICRATE*30
				spawnedmo.tics = TICRATE*30
			end
			spawnedmo.paraloop = true
			spawnedmo.becomeloop = 20
		end
		if trailmo == MT_GHOST
			spawnedmo.skin = mo.skin
			spawnedmo.state = mo.state
			spawnedmo.colorized = false
			spawnedmo.blendmode = AST_ADD
		end
    end
end

freeslot("MT_SPECIALRINGSNEW")

mobjinfo[MT_SPECIALRINGSNEW] = {
	doomednum = -1,
	spawnstate = S_RING,
	deathstate = S_SPRK1,
	spawnhealth = 1,
	speed = FRACUNIT*38,
	radius = 16*FRACUNIT,
	height = 58*FRACUNIT,
	dispoffset = 0,
	mass = 100,
	damage = 0,
	flags = MF_SCENERY|MF_SPECIAL|MF_NOGRAVITY
}

addHook("MobjThinker", function(mo) //Thok function
	if not mo then return end
	if not mo.valid then return end
	if not (mo.cyloopflash or mo.becomeloop or mo.paraloop or mo.cantusefuck) then return end
	
	if mo.cantusefuck
		mo.cantusefuck = $ - 1
	end
	if mo.cyloopflash
		if mo.scale < 2*FRACUNIT
			if not mo.goback
				mo.scale = $ + FRACUNIT/6
			else
				mo.scale = $ - FRACUNIT/4
			end	
		else
			mo.goback = true
			mo.scale = $ - FRACUNIT/4
		end	
	end
	if mo.becomeloop
		mo.becomeloop = $ - 1
		mo.becameit = true
	else
		if mo.becameit
			mo.becameit = false
			mo.flags = MF_SPECIAL|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SCENERY
		end	
	end	
	if mo.paraloop
		if mo.fuse <= 15
			mo.scale = $ - FRACUNIT/15
		end
		if (gametyperules & GTR_FRIENDLY) //Might be useful to throw someone off in competitive gametypes
		or (gametyperules & GTR_RACE)
			if mo.target and mo.target.valid
				if mo.target.player and mo.target.player.valid
					local player = mo.target.player
					local runsped = player.speed >= FixedMul(player.runspeed, player.mo.scale)
					if player.mo.eflags & MFE_UNDERWATER
						runsped = player.speed >= FixedMul(player.runspeed, player.mo.scale)/3
					else
						runsped = player.speed >= FixedMul(player.runspeed, player.mo.scale)
					end
					if ((not player.dashsped) or (player.dashsped and player.dashsped < DASHTHR))
					or (player.playerstate != PST_LIVE) or (player.powers[pw_carry] == CR_NIGHTSMODE)
					or not runsped
						mo.fuse = 15
						mo.paraloop = false
					end
				end
			end
		end	
	end
end, MT_THOK)

addHook("MobjThinker", function(mo) //Thok function
	if not mo then return end
	if not mo.valid then return end
	if not (mo.letsafuckinggo) then return end
	if not (canpikcupwithcyloop[mo.type]) then return end
	
	if mo.letsafuckinggo and mo.letsafuckinggo.valid
		P_FlyTo(mo, mo.letsafuckinggo.x, mo.letsafuckinggo.y, mo.letsafuckinggo.z, 60*FRACUNIT)
	end
end)

addHook("MobjThinker", function(mo) //Ring function
	if not mo then return end
	if not mo.valid then return end
	if not mo.cantbeused then return end
		if mo.cantbeused
			mo.cantbeused = $ - 1
		end
end, MT_SPECIALRINGSNEW)

for i = 1, 16
freeslot("SPR_FREX", "S_FRONTIERSEXPLOSION"..i, "sfx_delexp", "sfx_cyloop", "sfx_cylcls")
end

states[S_FRONTIERSEXPLOSION1] = {SPR_FREX, A, 2, nil, 0, 0, S_FRONTIERSEXPLOSION2}
states[S_FRONTIERSEXPLOSION2] = {SPR_FREX, B, 2, nil, 0, 0, S_FRONTIERSEXPLOSION3}
states[S_FRONTIERSEXPLOSION3] = {SPR_FREX, C, 2, nil, 0, 0, S_FRONTIERSEXPLOSION4}
states[S_FRONTIERSEXPLOSION4] = {SPR_FREX, D, 2, nil, 0, 0, S_FRONTIERSEXPLOSION5}
states[S_FRONTIERSEXPLOSION5] = {SPR_FREX, E, 2, nil, 0, 0, S_FRONTIERSEXPLOSION6}
states[S_FRONTIERSEXPLOSION6] = {SPR_FREX, F, 2, nil, 0, 0, S_FRONTIERSEXPLOSION7}
states[S_FRONTIERSEXPLOSION7] = {SPR_FREX, G, 2, nil, 0, 0, S_FRONTIERSEXPLOSION8}
states[S_FRONTIERSEXPLOSION8] = {SPR_FREX, H, 2, nil, 0, 0, S_FRONTIERSEXPLOSION9}
states[S_FRONTIERSEXPLOSION9] = {SPR_FREX, I, 2, nil, 0, 0, S_FRONTIERSEXPLOSION10}
states[S_FRONTIERSEXPLOSION10] = {SPR_FREX, J, 2, nil, 0, 0, S_FRONTIERSEXPLOSION11}
states[S_FRONTIERSEXPLOSION11] = {SPR_FREX, K, 2, nil, 0, 0, S_FRONTIERSEXPLOSION12}
states[S_FRONTIERSEXPLOSION12] = {SPR_FREX, L, 2, nil, 0, 0, S_FRONTIERSEXPLOSION13}
states[S_FRONTIERSEXPLOSION13] = {SPR_FREX, M, 2, nil, 0, 0, S_FRONTIERSEXPLOSION14}
states[S_FRONTIERSEXPLOSION14] = {SPR_FREX, N, 2, nil, 0, 0, S_FRONTIERSEXPLOSION15}
states[S_FRONTIERSEXPLOSION15] = {SPR_FREX, O, 2, nil, 0, 0, S_FRONTIERSEXPLOSION16}
states[S_FRONTIERSEXPLOSION16] = {SPR_FREX, P, 2, nil, 0, 0, S_NULL}

local function CheckPlayerDeath(mo, mobj)
	if mobj == mo
		return false
	end
	if mobj.player and mobj.player.valid
		if gametyperules & GTR_FRIENDLY
			return false
		else
			if gametyperules & GTR_TEAMS
				if mo.player and mo.player.valid
					if mobj.player.ctfteam == mo.player.ctfteam
						return false
					else
						return true
					end	
				end	
			else
				return true
			end	
		end
	end
end

rawset(_G, "canpikcupwithcyloop", {}) //Table for objects that can be picked up
canpikcupwithcyloop[MT_RING] = true //Misc
canpikcupwithcyloop[MT_FLINGRING] = true
canpikcupwithcyloop[MT_BLUESPHERE] = true
canpikcupwithcyloop[MT_FLINGBLUESPHERE] = true
canpikcupwithcyloop[MT_REDFLAG] = true  //Due to errors that are not fixable in any way or i just dont know why this isnt possbile
canpikcupwithcyloop[MT_BLUEFLAG] = true
//canpikcupwithcyloop[MT_EMBLEM] = true 

canpikcupwithcyloop[MT_EMERALD1] = true //Emeralds
canpikcupwithcyloop[MT_EMERALD2] = true
canpikcupwithcyloop[MT_EMERALD3] = true
canpikcupwithcyloop[MT_EMERALD4] = true
canpikcupwithcyloop[MT_EMERALD5] = true
canpikcupwithcyloop[MT_EMERALD6] = true
canpikcupwithcyloop[MT_EMERALD7] = true
canpikcupwithcyloop[MT_FLINGEMERALD] = true

canpikcupwithcyloop[MT_BOUNCERING] = true //Ringslinger panels and rings
canpikcupwithcyloop[MT_RAILRING] = true
canpikcupwithcyloop[MT_INFINITYRING] = true
canpikcupwithcyloop[MT_AUTOMATICRING] = true
canpikcupwithcyloop[MT_GRENADEPICKUP] = true
canpikcupwithcyloop[MT_SCATTERPICKUP] = true
canpikcupwithcyloop[MT_EXPLODEPICKUP] = true
canpikcupwithcyloop[MT_AUTOPICKUP] = true
canpikcupwithcyloop[MT_RAILPICKUP] = true
canpikcupwithcyloop[MT_BOUNCEPICKUP] = true
canpikcupwithcyloop[MT_GRENADERING] = true
canpikcupwithcyloop[MT_SCATTERRING] = true
canpikcupwithcyloop[MT_EXPLOSIONRING] = true

canpikcupwithcyloop[MT_COIN] = true //Mario
//canpikcupwithcyloop[MT_FLINGCOIN] = true
canpikcupwithcyloop[MT_FIREFLOWER] = true

addHook("TouchSpecial", function(special, toucher)
	if special and special.valid
		if special.paraloop
		and not special.cantusefuck
			if toucher and toucher.valid
				if toucher.player and toucher.player.valid
				and not toucher.player.spectator
				and toucher.player.powers[pw_carry] != CR_NIGHTSMODE
				and toucher.player.dashsped and toucher.player.dashsped >= 2*TICRATE
				and ((toucher.player.speed >= skins[toucher.skin].runspeed and not (toucher.eflags & MFE_UNDERWATER)) 
				or (toucher.player.speed >= (skins[toucher.skin].runspeed)/3 and toucher.eflags & MFE_UNDERWATER))
				and toucher.skin == "henchman"
					local mo2
					local count
					local x
					local y
					local z
					local bigx = 0
					local bigy = 0
					local bigz = 0
					local gatherradius
					local gatherradiusz
					local d
					local sparklestate = S_NULL
					
					if special.target != toucher
						return false
					end
					
					x = special.x>>FRACBITS
					y = special.y>>FRACBITS
					z = special.z>>FRACBITS
					count = 1
					
					for th in mobjs.iterate() //All the thoks
						mo2 = th
						
						if R_PointToDist2(special.x, special.y, mo2.x, mo2.y) >= 10000*FRACUNIT
							continue
						end
						
						if mo2 == special
							continue
						end
						
						if mo2.target != toucher
							continue
						end
						
						if not mo2.paraloop
							continue
						end
						
						if mo2.fuse >= special.fuse
							count = $ + 1 //How many of them
							x = $ + (mo2.x)>>FRACBITS
							y = $ + (mo2.y)>>FRACBITS
							z = $ + (mo2.z)>>FRACBITS
							local purple = P_SpawnMobjFromMobj(mo2, 0, 0, 0, MT_THOK)
							purple.color = SKINCOLOR_PURPLE
							purple.blendmode = AST_ADD
							purple.spriteyoffset = -8*FRACUNIT
							purple.fuse = TICRATE
							purple.tics = TICRATE
							purple.cyloopflash = true
						end
						mo2.cantusefuck = TICRATE
						P_KillMobj(mo2)
					end
					x = (x/count)<<FRACBITS //Get center
					y = (y/count)<<FRACBITS
					z = (z/count)<<FRACBITS
					gatherradius = P_AproxDistance(special.x - x, special.y - y)
					gatherradiusz = R_PointToDist2(0, special.z, 0, z) + 100*FRACUNIT
					special.cantusefuck = TICRATE
					P_KillMobj(special)
					
					if gatherradius <= 20*FRACUNIT
						return false
					end
					
					for i = 1, count
						local degree = ANG1*count
						local angle = i*degree
						local dist = gatherradius
						
						local addx = FixedMul(dist, cos(angle))
						local addy = FixedMul(dist, sin(angle))
						
						local closein = P_SpawnMobj(x+addx, y+addy, z, MT_THOK)
						if closein and closein.valid
							closein.scale = FRACUNIT/3*2
							closein.color = SKINCOLOR_WHITE
							closein.blendmode = AST_ADD
							P_InstaThrust(closein, R_PointToAngle2(closein.x, closein.y, x, y), dist/8)
							P_SetObjectMomZ(closein, (closein.z - z)/9)
						end	
					end
					toucher.player.cantdothecool = TICRATE
					S_StartSound(toucher, sfx_cylcls) //Cant hear shit
					S_StartSound(toucher, sfx_cdfm31)
					if S_SoundPlaying(toucher, sfx_cyloop)
						S_StopSoundByID(toucher, sfx_cyloop)
					end
					local foundsomething = false
					for th2 in mobjs.iterate()
						if (not th2.health)
							if (th2.flags & MF_MONITOR
							or th2.flags & MF_ENEMY
							or th2.flags & MF_BOSS)
								continue
							end
						end	
						if (R_PointToDist2(x, y, th2.x, th2.y) > gatherradius)
							continue
						end
						if R_PointToDist2(0, th2.z, 0, z) > gatherradiusz
							continue
						end
						if th2.type == MT_TARGET
						and th2.state != S_TARGET_ALLDONE
							th2.flags = $|MF_PUSHABLE
							foundsomething = true
						end
						if ((th2.flags & MF_ENEMY) or (th2.flags & MF_BOSS) or (th2.flags & MF_MONITOR))
						or (CheckPlayerDeath(toucher, th2)) or (th2.type == MT_SPIKE or th2.type == MT_WALLSPIKE 
						or th2.type == MT_WALLSPIKEBASE or th2.type == MT_TNTBARREL or th2.type == MT_PROXIMITYTNT)
						or (canpikcupwithcyloop[th2.type])
							if not (canpikcupwithcyloop[th2.type])
								local explosionfunny = P_SpawnMobjFromMobj(th2, 0, 0, 0, MT_THOK)
								explosionfunny.state = S_FRONTIERSEXPLOSION1
								explosionfunny.fuse = TICRATE*5
								S_StartSound(explosionfunny, sfx_delexp)
								if th2.health and th2.health >= 2
								and not (th2.flags & MF_BOSS)
									P_SetObjectMomZ(th2, 15*FRACUNIT)
								end
								P_DamageMobj(th2, toucher, toucher, 1, 0)
							else
								th2.letsafuckinggo = toucher
							end	
							foundsomething = true
							continue
						end
					end
				end
			end
			return true
		end	
	end
end)

local function SpeedHackCheck(player)
	if player.spedhack
		return true
	else	
		if (player.pflags & PF_SPINNING)
			return false
		else
			return true
		end
	end
end

addHook("PlayerThink", function(player)
	if player.valid and player.playerstate == PST_LIVE and player.powers[pw_carry] != CR_NIGHTSMODE
	and not player.spectator
	and (player.cmd.buttons & BT_CUSTOM3)
	and player.mo.skin == "henchman"
		player.dashsped = $ or 0
		player.standcel = $ or 0
		player.toolow = $ or 0
		player.wasdashmode = $ or 0
		player.goinfest = $ or 0
		player.cantdothecool = $ or 0
		player.speedhackactivated = $ or 0
		player.speedhackdeactivated = $ or 0
		if player.speedhackactivated
			player.speedhackactivated = $ - 1
		end
		if player.speedhackdeactivated
			player.speedhackdeactivated = $ - 1
		end
		if player.cantdothecool
			player.cantdothecool = $ - 1
		end
		if player.goinfest
			player.goinfest = $ - 1
		end
		if player.toolow
			player.toolow = $ - 1
		end
		if player.goingdown
			player.goinfest = 5
		end
		//player.asuscd = $ or 0
		//if player.asuscd
		//	player.asuscd = $ - 1
		//end
		local predash = player.dashsped
		local runsped = player.speed >= FixedMul(player.runspeed, player.mo.scale)
		if player.mo.eflags & MFE_UNDERWATER
			runsped = player.speed >= FixedMul(player.runspeed, player.mo.scale)/3
		else
			runsped = player.speed >= FixedMul(player.runspeed, player.mo.scale)
		end
		/*if player.cmd.buttons & BT_CUSTOM1
			if not player.asus
			and not player.asuscd
				player.asuscd = 20
				P_Thrust(player.mo, R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy), 15*FRACUNIT)
				if player.speed >= skins[player.mo.skin].normalspeed - 2*FRACUNIT
				and player.dashsped < DASHTHR
					player.dashsped = DASHTHR
				end
				S_StartSound(player.mo, sfx_zoom)
				S_StartSound(player.mo, sfx_thok)
				player.mo.state = S_PLAY_RUN
				P_SpawnThokMobj(player)
			end
			player.asus = true
		else
			player.asus = false
		end*/
		if not (player.gotflag)
		and not (player.powers[pw_carry])
		and not (player.exiting)
		and not (maptol & TOL_NIGHTS)
			if runsped and P_IsObjectOnGround(player.mo)
			and not player.gotflagdebuff
				if player.dashsped < DASHTHR
				and player.standcel
					if player.standcel >= 5
						player.standcel = $ - 5
					else
						player.standcel = 0
					end	
				end
				if player.dashsped < DASHMAX
					player.dashsped = $ + 1
					player.goingdown = false
					player.goinfest = 0
				end
				if player.dashsped <= DASHTHR
					player.toolow = 5
				end
				if player.dashsped == DASHTHR
					player.dashsped = $ + 1
					S_StartSound(player.mo, sfx_3db16)
				end
			end
			if not runsped
			and not ((player.pflags & PF_SPINNING) or (player.pflags & PF_STARTDASH))
			and P_IsObjectOnGround(player.mo)
				if S_SoundPlaying(player.mo, sfx_cyloop)
					S_StopSoundByID(player.mo, sfx_cyloop)
				end
				player.cantnomore = false
				if not player.cantdothecool
				and player.wasdashmode
					player.cantdothecool = 15
					if (gametyperules & GTR_TAG)
						player.cantdothecool = TICRATE*5
					end
					if P_IsObjectOnGround(player.mo)
						for i = 1, 5
							local destadd = 15*FRACUNIT + (i*(FRACUNIT*15))
							local addscale = (FRACUNIT*2) - i*(FRACUNIT/5)
							local momang = player.drawangle
							if player.speed
								momang = R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy)
							else
								momang = player.drawangle
							end
							
							local addx = FixedMul(destadd,cos(momang))
							local addy = FixedMul(destadd,sin(momang))
							
							local secheg = 0
							if P_MobjFlip(player.mo) == 1
								secheg = 0
							else
								secheg = player.mo.height/3*4-(destadd-15*FRACUNIT)
							end
							
					
							if not (gametyperules & GTR_FRIENDLY) //Might be useful to throw someone off in competitive gametypes
							and not (gametyperules & GTR_RACE)
								if (player.mo.eflags & MFE_UNDERWATER)
									arrow.fuse = TICRATE*7 -i
									arrow.tics = TICRATE*7 -i
								else
									arrow.fuse = TICRATE*6 -i
									arrow.tics = TICRATE*6 -i
								end
								if (gametyperules & GTR_TAG)
									arrow.fuse = TICRATE*30
									arrow.tics = TICRATE*30
								end
							end	
						end
					end	
				end
				if player.dashsped
					if player.dashsped > DASHTHR+2
						player.dashsped = DASHTHR+1
					else
						player.dashsped = $ - 1
					end	
					if not player.toolow //Honestly i have no idea why it works and how but it works so it stays
					and (player.wasdashmode or player.goinfest)
						//DrawFeet(player.mo, player.drawangle, player.dashsped) //Actually useless
						player.goingdown = true //And distracting
					end
					if player.dashsped == DASHTHR
						player.dashsped = $ - 1
						player.normalspeed = skins[player.mo.skin].normalspeed
						player.jumpfactor = skins[player.mo.skin].jumpfactor
						player.charflags = $ & ~SF_RUNONWATER
						S_StartSound(player.mo, sfx_cdfm17)
					end
				end
			end
			if player.dashsped >= DASHTHR/4*3
				if (player.cmd.forwardmove or player.cmd.sidemove)
				and player.dashsped >= DASHTHR
				and runsped and SpeedHackCheck(player)
				and (P_IsObjectOnGround(player.mo))
					local cmdangle = player.cmd.angleturn<<16 + R_PointToAngle2(0, 0, player.cmd.forwardmove*FRACUNIT, -player.cmd.sidemove<<16)
					P_Thrust(player.mo, cmdangle, FRACUNIT/2)
				end
			end
			if player.dashsped < DASHTHR/4*3
				if P_IsObjectOnGround(player.mo)
					player.normalspeed = skins[player.mo.skin].normalspeed
					player.jumpfactor = skins[player.mo.skin].jumpfactor
					if S_SoundPlaying(player.mo, sfx_cyloop)
						S_StopSoundByID(player.mo, sfx_cyloop)
					end
					player.cantnomore = false
					player.cantdothecool = 15
				end
			elseif P_IsObjectOnGround(player.mo)
				if player.dashsped >= DASHTHR + 5*TICRATE
					if player.normalspeed < 80*FRACUNIT
						player.normalspeed = $ + FRACUNIT/6
					end
					if player.jumpfactor < FixedMul(skins[player.mo.skin].jumpfactor, 5*FRACUNIT/4)
						player.jumpfactor = $ + FRACUNIT/300
					end
				end
				player.airwalk = false
				if runsped
					if player.powers[pw_shield] == SH_ELEMENTAL
						P_ElementalFire(player, false)
					end
					local dust = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_DUST)
					dust.momx = -player.mo.momx
					dust.momy = -player.mo.momy
					dust.momz = -player.mo.momz
					P_Thrust(dust, R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy)+ANGLE_90, P_RandomRange(-15, 15)*FRACUNIT)
					if player.normalspeed < 76*FRACUNIT
					and player.cantdothecool
						local ghost = P_SpawnGhostMobj(player.mo)
						ghost.fuse = 2
						ghost.colorized = false
						ghost.blendmode = AST_ADD
						if ghost.tracer and ghost.tracer.valid
							ghost.tracer.fuse = 2
						end
					end
				end	
			end
			if player.dashsped > DASHTHR
				if not player.cantdothecool
					if runsped
						SmoothTrail(player.mo, MT_THOK, 15*FRACUNIT, TICRATE*3)	
					
						if P_IsObjectOnGround(player.mo)
							for i = 1, 5
								local destadd = 15*FRACUNIT + (i*(FRACUNIT*15))
								local addscale = (FRACUNIT*2) - i*(FRACUNIT/5)
								local momang = player.drawangle
								if player.speed
									momang = R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy)
								else
									momang = player.drawangle
								end
								
								local addx = FixedMul(destadd,cos(momang))
								local addy = FixedMul(destadd,sin(momang))
								
								local secheg = 0
								if P_MobjFlip(player.mo) == 1
									secheg = 0
								else
									secheg = player.mo.height/3*4-(destadd-15*FRACUNIT)
								end
								
								local arrow = P_SpawnMobjFromMobj(player.mo, addx, addy, secheg, MT_NULL)
								arrow.color = player.mo.color
								arrow.target = player.mo
								arrow.scale = addscale
								arrow.spriteyoffset = -8*FRACUNIT
								arrow.blendmode = AST_ADD
								arrow.fuse = 3
								arrow.tics = 3
							end
						end
					end
					
					if (player.cmd.buttons & BT_CUSTOM3)
						if not S_SoundPlaying(player.mo, sfx_cyloop)
							S_StartSound(player.mo, sfx_cyloop)
						end
					else
						if S_SoundPlaying(player.mo, sfx_cyloop)
							S_StopSoundByID(player.mo, sfx_cyloop)
						end
					end	
				else
					if S_SoundPlaying(player.mo, sfx_cyloop)
						S_StopSoundByID(player.mo, sfx_cyloop)
					end
				end	
				
				if not runsped
					local ghost = P_SpawnGhostMobj(player.mo)
					ghost.colorized = true
					ghost.blendmode = AST_ADD
					ghost.color = player.mo.color
					ghost.momx = player.mo.momx
					ghost.momy = player.mo.momy
					ghost.momz = player.mo.momz
					if P_IsObjectOnGround(player.mo)
						P_Thrust(ghost, player.drawangle + P_RandomRange(-15,15)*ANG1, -15*FRACUNIT)
					end	
				end
				
				player.wasdashmode = 5
				player.charflags = $|SF_RUNONWATER
				if not player.ceilingd
					player.standcel = player.dashsped - TICRATE
				end	
				if player.dashsped >= 4*TICRATE
				and player.cantdothecool
					local ghost = P_SpawnGhostMobj(player.mo)
					ghost.fuse = 3
					if ghost.tracer and ghost.tracer.valid
						ghost.tracer.fuse = 3
					end
				end
			end
			if player.normalspeed >= 76*FRACUNIT
			and player.cantdothecool
				//player.maximumoverdrive = TICRATE
				local ghost = P_SpawnGhostMobj(player.mo)
				ghost.fuse = 6
				if ghost.tracer and ghost.tracer.valid
					ghost.tracer.fuse = 6
				end
			end
		elseif player.dashmode
			player.normalspeed = skins[player.mo.skin].normalspeed
			player.jumpfactor = skins[player.mo.skin].jumpfactor
			S_StartSound(player.mo, sfx_cdfm17)
		end
		if player.cmd.buttons & BT_JUMP
			player.supamaro = true
		else
			player.supamaro = false
		end
	end
end)

rawset(_G, "P_FlyTo", function(mo, fx, fy, fz, sped, addques)
	if mo.valid
		local flyto = P_AproxDistance(P_AproxDistance(fx - mo.x, fy - mo.y), fz - mo.z)
		if flyto < 1
			flyto = 1
		end
		local anglesucc = R_PointToAngle2(mo.x, mo.y, fx, fy)
		
		if addques
			mo.momx = $ + FixedMul(FixedDiv(fx - mo.x, flyto), sped)
			mo.momy = $ + FixedMul(FixedDiv(fy - mo.y, flyto), sped)
			mo.momz = $ + FixedMul(FixedDiv(fz - mo.z, flyto), sped)
		else
			mo.momx = FixedMul(FixedDiv(fx - mo.x, flyto), sped)
			mo.momy = FixedMul(FixedDiv(fy - mo.y, flyto), sped)
			mo.momz = FixedMul(FixedDiv(fz - mo.z, flyto), sped)
		end	
	end	
end) 