freeslot("MT_ENGIEOVERLAY")
mobjinfo[MT_ENGIEOVERLAY] = {
	-1,             // doomednum
	S_INVISIBLE,    // spawnstate
	1000,           // spawnhealth
	S_NULL,         // seestate
	sfx_None,       // seesound
	8,              // reactiontime
	sfx_None,       // attacksound
	S_NULL,         // painstate
	0,              // painchance
	sfx_None,       // painsound
	S_NULL,         // meleestate
	S_NULL,         // missilestate
	S_NULL,         // deathstate
	S_NULL,         // xdeathstate
	sfx_None,       // deathsound
	8,              // speed
	16*FRACUNIT,    // radius
	48*FRACUNIT,    // height
	2,              // display offset
	16,             // mass
	0,              // damage
	sfx_None,       // activesound
	MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SCENERY, // flags
	S_NULL          // raisestate
}

addHook("FollowMobj", function(player, tails)
		local smilesonground = P_IsObjectOnGround(player.mo)
		local horizangle = player.drawangle
		local zoffs = 0
		local backwards = -FRACUNIT
		local doswim = (player.panim == PA_ABILITY and (player.mo.eflags & MFE_UNDERWATER))
		local doroll = (player.panim == PA_ROLL or (player.panim == PA_JUMP and not (player.charflags & SF_NOJUMPSPIN)) or doswim)
		local rollangle
		local panimchange
		local ticnum = 0
		local chosenstate
		
		if not tails.skin
			tails.skin = player.mo.skin
			tails.state = S_TAILSOVERLAY_STAND
			tails.movecount = -1
		end
		
		panimchange = (tails.movecount != player.panim)
		
		if doroll
			local testval, zdist
			if player.speed < FRACUNIT
				testval = FRACUNIT
			else
				testval = (FixedMul(player.speed, cos((horizangle-R_PointToAngle2(0, 0, player.rmomx, player.rmomy)))))
				if testval < FRACUNIT
					testval = FRACUNIT
				end
			end
			if doswim
				zdist = player.mo.momz<<1
			elseif smilesonground and not player.mo.reactiontime
				zdist = (player.mo.z-tails.threshold)
			else
				zdist = player.mo.momz
			end
			rollangle = R_PointToAngle2(0, 0, testval, -P_MobjFlip(player.mo)*zdist)
			if not doswim
				zoffs = 3*FRACUNIT + 12*sin(rollangle)
				backwards = -12*cos(rollangle)
			end
		elseif player.panim == PA_RUN
			backwards = -5*FRACUNIT
		elseif (player.panim == PA_SPRING or player.panim == PA_JUMP)
			zoffs = $+FRACUNIT*4
			backwards = $/2
		elseif (player.panim == PA_FALL)
			zoffs = 0
			backwards = -FRACUNIT
		elseif player.panim == PA_PAIN
			backwards = $/16
		elseif player.mo.state == S_PLAY_GASP
			backwards = $/16
			zoffs = 12*FRACUNIT
		elseif player.mo.state == S_PLAY_EDGE
			backwards = $/16
			zoffs = 3*FRACUNIT
		elseif player.panim == PA_ABILITY2
			zoffs = -7*FRACUNIT
			backwards = -9*FRACUNIT
		elseif player.panim == PA_ABILITY
			backwards = -5*FRACUNIT
		end
		
		if doroll
			rollangle = $+ANG15
			if (rollangle > ANG60)
				chosenstate = S_TAILSOVERLAY_PLUS60DEGREES
			elseif (rollangle > ANG30)
				chosenstate = S_TAILSOVERLAY_PLUS30DEGREES
			elseif (rollangle < -ANG60)
				chosenstate = S_TAILSOVERLAY_MINUS60DEGREES
			elseif (rollangle < -ANG30)
				chosenstate = S_TAILSOVERLAY_MINUS30DEGREES
			else
				chosenstate = S_TAILSOVERLAY_0DEGREES
			end
		elseif (player.panim == PA_SPRING or player.panim == PA_JUMP)
			chosenstate = S_TAILSOVERLAY_MINUS60DEGREES
			tails.renderflags = $&~RF_VERTICALFLIP
		elseif (player.panim == PA_FALL or player.mo.state == S_PLAY_RIDE)
			chosenstate = S_TAILSOVERLAY_PLUS60DEGREES
		elseif (player.panim == PA_PAIN)
			chosenstate = S_TAILSOVERLAY_PAIN
		elseif (player.mo.state == S_PLAY_GASP)
			chosenstate = S_TAILSOVERLAY_GASP
		elseif (player.mo.state == S_PLAY_EDGE)
			chosenstate = S_TAILSOVERLAY_EDGE
		elseif (player.panim == PA_DASH)
			chosenstate = S_TAILSOVERLAY_DASH
		elseif (player.panim == PA_RUN)
			chosenstate = S_TAILSOVERLAY_RUN
		elseif (player.panim == PA_WALK)
			if (not smilesonground or player.mo.state == S_PLAY_SKID)
				chosenstate = S_TAILSOVERLAY_PLUS30DEGREES
			elseif (player.speed >= FixedMul(player.runspeed/2, player.mo.scale))
				chosenstate = S_TAILSOVERLAY_0DEGREES
			else
				chosenstate = S_TAILSOVERLAY_MINUS30DEGREES
			end
		elseif (player.mo.sprite2 == SPR2_FLY)
			chosenstate = S_TAILSOVERLAY_FLY
		elseif (player.mo.sprite2 == SPR2_SWIM)
			chosenstate = S_TAILSOVERLAY_FLY
		elseif (player.mo.sprite2 == SPR2_TIRE)
			chosenstate = S_TAILSOVERLAY_TIRE
		elseif (player.panim == PA_ABILITY2)
			chosenstate = S_TAILSOVERLAY_PLUS30DEGREES
		elseif (player.panim == PA_IDLE)
			chosenstate = S_TAILSOVERLAY_STAND
		else
			chosenstate = S_TAILSOVERLAY_0DEGREES
		end
		
		if panimchange
			tails.state = chosenstate
		else
			if tails.state != chosenstate
				tails.state = chosenstate
			end
		end
		
		if (player.panim == PA_SPRING or player.panim == PA_FALL or player.mo.state == S_PLAY_RIDE)
			if (FixedDiv(abs(player.mo.momz), player.mo.scale) < 20<<FRACBITS)
				ticnum = 2
			else
				ticnum = 1
			end
		elseif (player.panim == PA_PAIN)
			ticnum = 2
		elseif (player.mo.state == S_PLAY_GASP)
			tails.tics = -1
		elseif (player.mo.sprite2 == SPR2_TIRE)
			if doswim
				ticnum = 2
			else
				ticnum = 4
			end
		elseif (player.panim != PA_IDLE)
			ticnum = player.mo.tics
		end

		if (ticnum and tails.tics > ticnum)
			tails.tics = ticnum
		end
		
		tails.color = player.mo.color
		tails.threshold = player.mo.z
		tails.movecount = player.panim
		tails.angle = player.drawangle
		tails.scale = player.mo.scale
		tails.destscale = player.mo.destscale
		tails.rollangle = player.mo.rollangle
		tails.spriteyscale = player.mo.spriteyscale
		tails.spritexscale = player.mo.spritexscale
		tails.radius = player.mo.radius
		tails.height = player.mo.height
		
		if P_MobjFlip(player.mo) == -1
			tails.eflags = $|MFE_VERTICALFLIP
			tails.flags2 = $|MF2_OBJECTFLIP
			zoffs = player.mo.height - tails.height - zoffs
		else
			tails.eflags = $&~MFE_VERTICALFLIP
			tails.flags2 = $&~MF2_OBJECTFLIP
		end
		
		P_ChangeOrigin(tails, 
			player.mo.x+P_ReturnThrustX(tails, tails.angle, FixedMul(backwards, tails.scale)),
			player.mo.y+P_ReturnThrustY(tails, tails.angle, FixedMul(backwards, tails.scale)),
			player.mo.z+zoffs,true)
		return true
end, MT_ENGIEOVERLAY)