addHook("PlayerSpawn", function(player)
	if player.valid and player.mo and player.mo.valid and player.mo.skin == "henchman"
	and not player.spectator and player.playerstate == PST_LIVE
		player.si_wallstuff = {}
	end
end)

addHook("PlayerThink", function(player)
	if player.valid and player.mo and player.mo.valid and player.mo.skin == "na"
	and not player.spectator and player.playerstate == PST_LIVE
		local mo = player.mo
		if not player.si_wallstuff 
			player.si_wallstuff = {}
			player.si_wallstuff.walljump = 0
			player.si_wallstuff.jumpang = 0
			player.si_wallstuff.jumpcd = 0
			player.si_wallstuff.touchwall = 0
			player.si_wallstuff.wallang = 0
			player.si_wallstuff.savespeed = 0
			player.si_wallstuff.nospeed = 0
		end
		if player.si_wallstuff.jumpcd
			player.si_wallstuff.jumpcd = $-1
		end
		player.si_wallstuff.savespeed = $ or 0
		player.si_wallstuff.nospeed = $ or 0
		if player.si_wallstuff.savespeed
			player.si_wallstuff.nospeed = $+FRACUNIT
			player.si_wallstuff.savespeed = max($-player.si_wallstuff.nospeed,0)
		end
		if player.si_wallstuff.savespeed < player.speed
			player.si_wallstuff.nospeed = FRACUNIT
			player.si_wallstuff.savespeed = player.speed
		end
		if player.si_wallstuff.touchwall
			player.si_wallstuff.touchwall = $-1
			player.si_wallstuff.touched = true
		elseif player.si_wallstuff.touched
			player.si_wallstuff.touched = false
			player.si_wallstuff.dowalljump = false
		end
		if player.si_wallstuff.walljump
			player.si_wallstuff.walljump = $-1
			mo.state = S_PLAY_WALK
			
			local diff = player.si_wallstuff.jumpang-player.si_wallstuff.drawang
			local factor = 12
			if diff > ANGLE_180 then diff = InvAngle(InvAngle($)/factor) else diff = $/factor end
			player.si_wallstuff.drawang = $+diff
			
			if diff <= ANG2
				player.si_wallstuff.drawang = player.si_wallstuff.jumpang
			end
			player.drawangle = player.si_wallstuff.drawang
			
			player.si_wallstuff.walljumped = true
		elseif player.si_wallstuff.walljumped
			player.si_wallstuff.walljumped = false
			mo.state = S_PLAY_JUMP
			player.pflags = $&~PF_THOKKED
		end
		if P_IsObjectOnGround(mo)
			player.si_wallstuff.jumpcd = 0
			player.si_wallstuff.walljumped = false
			player.si_wallstuff.walljump = 0
		end
		
		if player.si_wallstuff.dowalljump
		and not player.si_wallstuff.jumpcd
		and not P_IsObjectOnGround(mo)
			player.si_wallstuff.dowalljump = false
			
			P_DoJump(player)
			player.pflags = $&~PF_THOKKED
			player.si_wallstuff.walljump = 16
			
			player.si_wallstuff.savespeed = $ or 0
			local wallforce = 16*FRACUNIT-(player.si_wallstuff.savespeed/2)
			if (mo.eflags & MFE_UNDERWATER) then wallforce = $/3*2 end
			P_SetObjectMomZ(mo,wallforce,true)
			player.si_wallstuff.nospeed = player.si_wallstuff.savespeed
			
			local jumpang = player.si_wallstuff.wallang+ANGLE_180
			P_Thrust(mo,jumpang,16*mo.scale)
			
			player.drawangle = player.si_wallstuff.wallang
			player.si_wallstuff.jumpang = jumpang
			player.si_wallstuff.drawang = jumpang
			player.si_wallstuff.jumpcd = 20
			
			mo.state = S_PLAY_WALK
			mo.frame = (($|FF_FRAMEMASK)+2)|($&~FF_FRAMEMASK)
			
			local f = P_SpawnMobjFromMobj(mo,mo.momx*2,mo.momy*2,mo.momz*2,MT_THOK)
			f.state = S_FACESTABBERSPEAR
			f.angle = jumpang+ANGLE_90
			f.colorized = true
			f.color = mo.color
			f.blendmode = AST_ADD
			f.scale = mo.scale/6
			f.destscale = mo.scale*6
			f.fuse = 12
			
			f.momx = -mo.momx/4
			f.momy = -mo.momy/4
			f.momz = -mo.momz/4
		end
	end
end)

addHook("PlayerCmd", function(player,cmd)
	if player.valid and player.mo and player.mo.valid and player.mo.skin == "henchman"
	and not player.spectator and player.playerstate == PST_LIVE
	and player.si_wallstuff
		if (cmd.buttons & BT_JUMP)
		and not (player.pflags & PF_JUMPDOWN)
			if player.si_wallstuff.touchwall
			and not player.si_wallstuff.jumpcd
			and not P_IsObjectOnGround(player.mo)
			and not player.si_wallstuff.dowalljump
				cmd.buttons = $&~BT_JUMP
				player.si_wallstuff.dowalljump = true
			end
		end
	end
end)

local function W_DoWallStuff(mo,ang)
	local player = mo.player
	
	if not player.si_wallstuff.jumpcd
	and not P_IsObjectOnGround(player.mo)
	and not player.si_wallstuff.dowalljump
		P_SlideMove(mo)
		
		local rx = P_ReturnThrustX(nil,ang,mo.radius/2)
		local ry = P_ReturnThrustY(nil,ang,mo.radius/2)
		local d = P_SpawnMobjFromMobj(mo,rx,ry,0,MT_DUST)
		d.flags = $&~MF_NOCLIP
		
		local rana = P_RandomRange(-90,90)*ANG1
		P_InstaThrust(d,ang+rana,FixedMul(sin(abs(rana)),16*mo.scale))
		P_SetObjectMomZ(d,-mo.momz/2)
		
		player.si_wallstuff.touchwall = 6
		player.si_wallstuff.wallang = ang
	end
end

addHook("MobjMoveBlocked", function(mo,mobj,line)
	if mo and mo.valid
	and not (mobj and mobj.valid and mobj.flags & (MF_MONITOR|MF_ENEMY|MF_BOSS))
		if line and line.valid
			if PTR_GlideClimbTraverse(mo,line)
			and mo.player and mo.player.valid
				local real,ang = PTR_GlideClimbTraverse(mo,line)
				if (P_IsClimbingValid(mo.player,ang) or (mobj and mobj.valid))
					if mobj and mobj.valid then ang = R_PointToAngle2(mo.x,mo.y,mobj.x,mobj.y) end
					W_DoWallStuff(mo,ang)
				end
			end
		elseif mobj and mobj.valid
			local ang = R_PointToAngle2(mo.x,mo.y,mobj.x,mobj.y)
			W_DoWallStuff(mo,ang)
		end
	end
end,MT_PLAYER)